/**
*	 "CBookItems"     
*	     ,    ,   
*	      ,   
*	       
*	     ,   
*	       
*	       
*/

#pragma once
#include <iostream>
#include <string>
#include <vector>
#include <fstream>

using namespace std;


class CBookItems
{
public:
  template<class T>
	class BaseBookItem
	{
		protected:
			T _sFirstName;
			T _sLastName;
			T _sPhoneNumber1;
			T _sPhoneNumber2;
		public:
			BaseBookItem()
			{
			}
			virtual ~BaseBookItem()
			{
			}
			virtual const string to_string() const = 0;
  };

  class BookItem : BaseBookItem<string>
  {
    public:
      BookItem()
      {
      }
      virtual ~BookItem()
      {
      }
  		//===============================================================================
  		/**
  		*  /
  		*/
  		friend std::ostream& operator<<(std::ostream& s, const BookItem& item);
  		friend std::istream& operator>>(std::istream& s, BookItem& item);

      friend CBookItems;
      const string to_string() const;
  };

	vector<BookItem> _aItems;

public:
	
	//===============================================================================
	/**
	*       
	*/
	void CreateNewItem(string sFirstName, string sLastName, string sPhoneNumber1);
	
	//===============================================================================
	/**
	*        (2 )
	*/
	void CreateNewItem(string sFirstName, string sLastName, string sPhoneNumber1, string sPhoneNumber2);

	//===============================================================================
	/**
	*     
	*/
	int SetNewValueToItem(string sFirstName, string sLastName, string sPhoneNumber1, int nNumOfItem);

	//===============================================================================
	/**
	*      (2 )
	*/
	int SetNewValueToItem(string sFirstName, string sLastName, string sPhoneNumber1, string sPhoneNumber2, int nNumOfItem);

	//===============================================================================
	/**
	*    
	*/
	int GetItem(int nNumOfItem, string& sFirstName, string& sLastName, string& sPhoneNumber1);

	//===============================================================================
	/**
	*     (2 )
	*/
	int GetItem(int nNumOfItem, string& sFirstName, string& sLastName, string& sPhoneNumber1, string& sPhoneNumber2);

	//===============================================================================
	/**
	*   
	*/
	const BookItem& GetItem(int nNumOfItem);

	//===============================================================================
	/**
	*     
	*/
	int GetSize();

	//===============================================================================
	/**
	*       
	*/
	int SortItems(int nSortingType);

	//===============================================================================
	/**
	*   ,     
	*/
	int FindItem(string sDesiredValue, int nSortingType, vector<int>& nNumOfDesirvedItems);

	//===============================================================================
	/**
	*    
	*/
	int SaveItems(string sNameOfFile);

	//===============================================================================
	/**
	*    
	*/
	int LoadItems(string sNameOfFile);
};